Browse code

Fresh slate, new goals

Jaidyn Lev authored on 2019-01-06 02:27:22
Showing 17 changed files
1 1
new file mode 100644
... ...
@@ -0,0 +1,674 @@
1
+                    GNU GENERAL PUBLIC LICENSE
2
+                       Version 3, 29 June 2007
3
+
4
+ Copyright (C) 2007 Free Software Foundation, Inc. <https://fsf.org/>
5
+ Everyone is permitted to copy and distribute verbatim copies
6
+ of this license document, but changing it is not allowed.
7
+
8
+                            Preamble
9
+
10
+  The GNU General Public License is a free, copyleft license for
11
+software and other kinds of works.
12
+
13
+  The licenses for most software and other practical works are designed
14
+to take away your freedom to share and change the works.  By contrast,
15
+the GNU General Public License is intended to guarantee your freedom to
16
+share and change all versions of a program--to make sure it remains free
17
+software for all its users.  We, the Free Software Foundation, use the
18
+GNU General Public License for most of our software; it applies also to
19
+any other work released this way by its authors.  You can apply it to
20
+your programs, too.
21
+
22
+  When we speak of free software, we are referring to freedom, not
23
+price.  Our General Public Licenses are designed to make sure that you
24
+have the freedom to distribute copies of free software (and charge for
25
+them if you wish), that you receive source code or can get it if you
26
+want it, that you can change the software or use pieces of it in new
27
+free programs, and that you know you can do these things.
28
+
29
+  To protect your rights, we need to prevent others from denying you
30
+these rights or asking you to surrender the rights.  Therefore, you have
31
+certain responsibilities if you distribute copies of the software, or if
32
+you modify it: responsibilities to respect the freedom of others.
33
+
34
+  For example, if you distribute copies of such a program, whether
35
+gratis or for a fee, you must pass on to the recipients the same
36
+freedoms that you received.  You must make sure that they, too, receive
37
+or can get the source code.  And you must show them these terms so they
38
+know their rights.
39
+
40
+  Developers that use the GNU GPL protect your rights with two steps:
41
+(1) assert copyright on the software, and (2) offer you this License
42
+giving you legal permission to copy, distribute and/or modify it.
43
+
44
+  For the developers' and authors' protection, the GPL clearly explains
45
+that there is no warranty for this free software.  For both users' and
46
+authors' sake, the GPL requires that modified versions be marked as
47
+changed, so that their problems will not be attributed erroneously to
48
+authors of previous versions.
49
+
50
+  Some devices are designed to deny users access to install or run
51
+modified versions of the software inside them, although the manufacturer
52
+can do so.  This is fundamentally incompatible with the aim of
53
+protecting users' freedom to change the software.  The systematic
54
+pattern of such abuse occurs in the area of products for individuals to
55
+use, which is precisely where it is most unacceptable.  Therefore, we
56
+have designed this version of the GPL to prohibit the practice for those
57
+products.  If such problems arise substantially in other domains, we
58
+stand ready to extend this provision to those domains in future versions
59
+of the GPL, as needed to protect the freedom of users.
60
+
61
+  Finally, every program is threatened constantly by software patents.
62
+States should not allow patents to restrict development and use of
63
+software on general-purpose computers, but in those that do, we wish to
64
+avoid the special danger that patents applied to a free program could
65
+make it effectively proprietary.  To prevent this, the GPL assures that
66
+patents cannot be used to render the program non-free.
67
+
68
+  The precise terms and conditions for copying, distribution and
69
+modification follow.
70
+
71
+                       TERMS AND CONDITIONS
72
+
73
+  0. Definitions.
74
+
75
+  "This License" refers to version 3 of the GNU General Public License.
76
+
77
+  "Copyright" also means copyright-like laws that apply to other kinds of
78
+works, such as semiconductor masks.
79
+
80
+  "The Program" refers to any copyrightable work licensed under this
81
+License.  Each licensee is addressed as "you".  "Licensees" and
82
+"recipients" may be individuals or organizations.
83
+
84
+  To "modify" a work means to copy from or adapt all or part of the work
85
+in a fashion requiring copyright permission, other than the making of an
86
+exact copy.  The resulting work is called a "modified version" of the
87
+earlier work or a work "based on" the earlier work.
88
+
89
+  A "covered work" means either the unmodified Program or a work based
90
+on the Program.
91
+
92
+  To "propagate" a work means to do anything with it that, without
93
+permission, would make you directly or secondarily liable for
94
+infringement under applicable copyright law, except executing it on a
95
+computer or modifying a private copy.  Propagation includes copying,
96
+distribution (with or without modification), making available to the
97
+public, and in some countries other activities as well.
98
+
99
+  To "convey" a work means any kind of propagation that enables other
100
+parties to make or receive copies.  Mere interaction with a user through
101
+a computer network, with no transfer of a copy, is not conveying.
102
+
103
+  An interactive user interface displays "Appropriate Legal Notices"
104
+to the extent that it includes a convenient and prominently visible
105
+feature that (1) displays an appropriate copyright notice, and (2)
106
+tells the user that there is no warranty for the work (except to the
107
+extent that warranties are provided), that licensees may convey the
108
+work under this License, and how to view a copy of this License.  If
109
+the interface presents a list of user commands or options, such as a
110
+menu, a prominent item in the list meets this criterion.
111
+
112
+  1. Source Code.
113
+
114
+  The "source code" for a work means the preferred form of the work
115
+for making modifications to it.  "Object code" means any non-source
116
+form of a work.
117
+
118
+  A "Standard Interface" means an interface that either is an official
119
+standard defined by a recognized standards body, or, in the case of
120
+interfaces specified for a particular programming language, one that
121
+is widely used among developers working in that language.
122
+
123
+  The "System Libraries" of an executable work include anything, other
124
+than the work as a whole, that (a) is included in the normal form of
125
+packaging a Major Component, but which is not part of that Major
126
+Component, and (b) serves only to enable use of the work with that
127
+Major Component, or to implement a Standard Interface for which an
128
+implementation is available to the public in source code form.  A
129
+"Major Component", in this context, means a major essential component
130
+(kernel, window system, and so on) of the specific operating system
131
+(if any) on which the executable work runs, or a compiler used to
132
+produce the work, or an object code interpreter used to run it.
133
+
134
+  The "Corresponding Source" for a work in object code form means all
135
+the source code needed to generate, install, and (for an executable
136
+work) run the object code and to modify the work, including scripts to
137
+control those activities.  However, it does not include the work's
138
+System Libraries, or general-purpose tools or generally available free
139
+programs which are used unmodified in performing those activities but
140
+which are not part of the work.  For example, Corresponding Source
141
+includes interface definition files associated with source files for
142
+the work, and the source code for shared libraries and dynamically
143
+linked subprograms that the work is specifically designed to require,
144
+such as by intimate data communication or control flow between those
145
+subprograms and other parts of the work.
146
+
147
+  The Corresponding Source need not include anything that users
148
+can regenerate automatically from other parts of the Corresponding
149
+Source.
150
+
151
+  The Corresponding Source for a work in source code form is that
152
+same work.
153
+
154
+  2. Basic Permissions.
155
+
156
+  All rights granted under this License are granted for the term of
157
+copyright on the Program, and are irrevocable provided the stated
158
+conditions are met.  This License explicitly affirms your unlimited
159
+permission to run the unmodified Program.  The output from running a
160
+covered work is covered by this License only if the output, given its
161
+content, constitutes a covered work.  This License acknowledges your
162
+rights of fair use or other equivalent, as provided by copyright law.
163
+
164
+  You may make, run and propagate covered works that you do not
165
+convey, without conditions so long as your license otherwise remains
166
+in force.  You may convey covered works to others for the sole purpose
167
+of having them make modifications exclusively for you, or provide you
168
+with facilities for running those works, provided that you comply with
169
+the terms of this License in conveying all material for which you do
170
+not control copyright.  Those thus making or running the covered works
171
+for you must do so exclusively on your behalf, under your direction
172
+and control, on terms that prohibit them from making any copies of
173
+your copyrighted material outside their relationship with you.
174
+
175
+  Conveying under any other circumstances is permitted solely under
176
+the conditions stated below.  Sublicensing is not allowed; section 10
177
+makes it unnecessary.
178
+
179
+  3. Protecting Users' Legal Rights From Anti-Circumvention Law.
180
+
181
+  No covered work shall be deemed part of an effective technological
182
+measure under any applicable law fulfilling obligations under article
183
+11 of the WIPO copyright treaty adopted on 20 December 1996, or
184
+similar laws prohibiting or restricting circumvention of such
185
+measures.
186
+
187
+  When you convey a covered work, you waive any legal power to forbid
188
+circumvention of technological measures to the extent such circumvention
189
+is effected by exercising rights under this License with respect to
190
+the covered work, and you disclaim any intention to limit operation or
191
+modification of the work as a means of enforcing, against the work's
192
+users, your or third parties' legal rights to forbid circumvention of
193
+technological measures.
194
+
195
+  4. Conveying Verbatim Copies.
196
+
197
+  You may convey verbatim copies of the Program's source code as you
198
+receive it, in any medium, provided that you conspicuously and
199
+appropriately publish on each copy an appropriate copyright notice;
200
+keep intact all notices stating that this License and any
201
+non-permissive terms added in accord with section 7 apply to the code;
202
+keep intact all notices of the absence of any warranty; and give all
203
+recipients a copy of this License along with the Program.
204
+
205
+  You may charge any price or no price for each copy that you convey,
206
+and you may offer support or warranty protection for a fee.
207
+
208
+  5. Conveying Modified Source Versions.
209
+
210
+  You may convey a work based on the Program, or the modifications to
211
+produce it from the Program, in the form of source code under the
212
+terms of section 4, provided that you also meet all of these conditions:
213
+
214
+    a) The work must carry prominent notices stating that you modified
215
+    it, and giving a relevant date.
216
+
217
+    b) The work must carry prominent notices stating that it is
218
+    released under this License and any conditions added under section
219
+    7.  This requirement modifies the requirement in section 4 to
220
+    "keep intact all notices".
221
+
222
+    c) You must license the entire work, as a whole, under this
223
+    License to anyone who comes into possession of a copy.  This
224
+    License will therefore apply, along with any applicable section 7
225
+    additional terms, to the whole of the work, and all its parts,
226
+    regardless of how they are packaged.  This License gives no
227
+    permission to license the work in any other way, but it does not
228
+    invalidate such permission if you have separately received it.
229
+
230
+    d) If the work has interactive user interfaces, each must display
231
+    Appropriate Legal Notices; however, if the Program has interactive
232
+    interfaces that do not display Appropriate Legal Notices, your
233
+    work need not make them do so.
234
+
235
+  A compilation of a covered work with other separate and independent
236
+works, which are not by their nature extensions of the covered work,
237
+and which are not combined with it such as to form a larger program,
238
+in or on a volume of a storage or distribution medium, is called an
239
+"aggregate" if the compilation and its resulting copyright are not
240
+used to limit the access or legal rights of the compilation's users
241
+beyond what the individual works permit.  Inclusion of a covered work
242
+in an aggregate does not cause this License to apply to the other
243
+parts of the aggregate.
244
+
245
+  6. Conveying Non-Source Forms.
246
+
247
+  You may convey a covered work in object code form under the terms
248
+of sections 4 and 5, provided that you also convey the
249
+machine-readable Corresponding Source under the terms of this License,
250
+in one of these ways:
251
+
252
+    a) Convey the object code in, or embodied in, a physical product
253
+    (including a physical distribution medium), accompanied by the
254
+    Corresponding Source fixed on a durable physical medium
255
+    customarily used for software interchange.
256
+
257
+    b) Convey the object code in, or embodied in, a physical product
258
+    (including a physical distribution medium), accompanied by a
259
+    written offer, valid for at least three years and valid for as
260
+    long as you offer spare parts or customer support for that product
261
+    model, to give anyone who possesses the object code either (1) a
262
+    copy of the Corresponding Source for all the software in the
263
+    product that is covered by this License, on a durable physical
264
+    medium customarily used for software interchange, for a price no
265
+    more than your reasonable cost of physically performing this
266
+    conveying of source, or (2) access to copy the
267
+    Corresponding Source from a network server at no charge.
268
+
269
+    c) Convey individual copies of the object code with a copy of the
270
+    written offer to provide the Corresponding Source.  This
271
+    alternative is allowed only occasionally and noncommercially, and
272
+    only if you received the object code with such an offer, in accord
273
+    with subsection 6b.
274
+
275
+    d) Convey the object code by offering access from a designated
276
+    place (gratis or for a charge), and offer equivalent access to the
277
+    Corresponding Source in the same way through the same place at no
278
+    further charge.  You need not require recipients to copy the
279
+    Corresponding Source along with the object code.  If the place to
280
+    copy the object code is a network server, the Corresponding Source
281
+    may be on a different server (operated by you or a third party)
282
+    that supports equivalent copying facilities, provided you maintain
283
+    clear directions next to the object code saying where to find the
284
+    Corresponding Source.  Regardless of what server hosts the
285
+    Corresponding Source, you remain obligated to ensure that it is
286
+    available for as long as needed to satisfy these requirements.
287
+
288
+    e) Convey the object code using peer-to-peer transmission, provided
289
+    you inform other peers where the object code and Corresponding
290
+    Source of the work are being offered to the general public at no
291
+    charge under subsection 6d.
292
+
293
+  A separable portion of the object code, whose source code is excluded
294
+from the Corresponding Source as a System Library, need not be
295
+included in conveying the object code work.
296
+
297
+  A "User Product" is either (1) a "consumer product", which means any
298
+tangible personal property which is normally used for personal, family,
299
+or household purposes, or (2) anything designed or sold for incorporation
300
+into a dwelling.  In determining whether a product is a consumer product,
301
+doubtful cases shall be resolved in favor of coverage.  For a particular
302
+product received by a particular user, "normally used" refers to a
303
+typical or common use of that class of product, regardless of the status
304
+of the particular user or of the way in which the particular user
305
+actually uses, or expects or is expected to use, the product.  A product
306
+is a consumer product regardless of whether the product has substantial
307
+commercial, industrial or non-consumer uses, unless such uses represent
308
+the only significant mode of use of the product.
309
+
310
+  "Installation Information" for a User Product means any methods,
311
+procedures, authorization keys, or other information required to install
312
+and execute modified versions of a covered work in that User Product from
313
+a modified version of its Corresponding Source.  The information must
314
+suffice to ensure that the continued functioning of the modified object
315
+code is in no case prevented or interfered with solely because
316
+modification has been made.
317
+
318
+  If you convey an object code work under this section in, or with, or
319
+specifically for use in, a User Product, and the conveying occurs as
320
+part of a transaction in which the right of possession and use of the
321
+User Product is transferred to the recipient in perpetuity or for a
322
+fixed term (regardless of how the transaction is characterized), the
323
+Corresponding Source conveyed under this section must be accompanied
324
+by the Installation Information.  But this requirement does not apply
325
+if neither you nor any third party retains the ability to install
326
+modified object code on the User Product (for example, the work has
327
+been installed in ROM).
328
+
329
+  The requirement to provide Installation Information does not include a
330
+requirement to continue to provide support service, warranty, or updates
331
+for a work that has been modified or installed by the recipient, or for
332
+the User Product in which it has been modified or installed.  Access to a
333
+network may be denied when the modification itself materially and
334
+adversely affects the operation of the network or violates the rules and
335
+protocols for communication across the network.
336
+
337
+  Corresponding Source conveyed, and Installation Information provided,
338
+in accord with this section must be in a format that is publicly
339
+documented (and with an implementation available to the public in
340
+source code form), and must require no special password or key for
341
+unpacking, reading or copying.
342
+
343
+  7. Additional Terms.
344
+
345
+  "Additional permissions" are terms that supplement the terms of this
346
+License by making exceptions from one or more of its conditions.
347
+Additional permissions that are applicable to the entire Program shall
348
+be treated as though they were included in this License, to the extent
349
+that they are valid under applicable law.  If additional permissions
350
+apply only to part of the Program, that part may be used separately
351
+under those permissions, but the entire Program remains governed by
352
+this License without regard to the additional permissions.
353
+
354
+  When you convey a copy of a covered work, you may at your option
355
+remove any additional permissions from that copy, or from any part of
356
+it.  (Additional permissions may be written to require their own
357
+removal in certain cases when you modify the work.)  You may place
358
+additional permissions on material, added by you to a covered work,
359
+for which you have or can give appropriate copyright permission.
360
+
361
+  Notwithstanding any other provision of this License, for material you
362
+add to a covered work, you may (if authorized by the copyright holders of
363
+that material) supplement the terms of this License with terms:
364
+
365
+    a) Disclaiming warranty or limiting liability differently from the
366
+    terms of sections 15 and 16 of this License; or
367
+
368
+    b) Requiring preservation of specified reasonable legal notices or
369
+    author attributions in that material or in the Appropriate Legal
370
+    Notices displayed by works containing it; or
371
+
372
+    c) Prohibiting misrepresentation of the origin of that material, or
373
+    requiring that modified versions of such material be marked in
374
+    reasonable ways as different from the original version; or
375
+
376
+    d) Limiting the use for publicity purposes of names of licensors or
377
+    authors of the material; or
378
+
379
+    e) Declining to grant rights under trademark law for use of some
380
+    trade names, trademarks, or service marks; or
381
+
382
+    f) Requiring indemnification of licensors and authors of that
383
+    material by anyone who conveys the material (or modified versions of
384
+    it) with contractual assumptions of liability to the recipient, for
385
+    any liability that these contractual assumptions directly impose on
386
+    those licensors and authors.
387
+
388
+  All other non-permissive additional terms are considered "further
389
+restrictions" within the meaning of section 10.  If the Program as you
390
+received it, or any part of it, contains a notice stating that it is
391
+governed by this License along with a term that is a further
392
+restriction, you may remove that term.  If a license document contains
393
+a further restriction but permits relicensing or conveying under this
394
+License, you may add to a covered work material governed by the terms
395
+of that license document, provided that the further restriction does
396
+not survive such relicensing or conveying.
397
+
398
+  If you add terms to a covered work in accord with this section, you
399
+must place, in the relevant source files, a statement of the
400
+additional terms that apply to those files, or a notice indicating
401
+where to find the applicable terms.
402
+
403
+  Additional terms, permissive or non-permissive, may be stated in the
404
+form of a separately written license, or stated as exceptions;
405
+the above requirements apply either way.
406
+
407
+  8. Termination.
408
+
409
+  You may not propagate or modify a covered work except as expressly
410
+provided under this License.  Any attempt otherwise to propagate or
411
+modify it is void, and will automatically terminate your rights under
412
+this License (including any patent licenses granted under the third
413
+paragraph of section 11).
414
+
415
+  However, if you cease all violation of this License, then your
416
+license from a particular copyright holder is reinstated (a)
417
+provisionally, unless and until the copyright holder explicitly and
418
+finally terminates your license, and (b) permanently, if the copyright
419
+holder fails to notify you of the violation by some reasonable means
420
+prior to 60 days after the cessation.
421
+
422
+  Moreover, your license from a particular copyright holder is
423
+reinstated permanently if the copyright holder notifies you of the
424
+violation by some reasonable means, this is the first time you have
425
+received notice of violation of this License (for any work) from that
426
+copyright holder, and you cure the violation prior to 30 days after
427
+your receipt of the notice.
428
+
429
+  Termination of your rights under this section does not terminate the
430
+licenses of parties who have received copies or rights from you under
431
+this License.  If your rights have been terminated and not permanently
432
+reinstated, you do not qualify to receive new licenses for the same
433
+material under section 10.
434
+
435
+  9. Acceptance Not Required for Having Copies.
436
+
437
+  You are not required to accept this License in order to receive or
438
+run a copy of the Program.  Ancillary propagation of a covered work
439
+occurring solely as a consequence of using peer-to-peer transmission
440
+to receive a copy likewise does not require acceptance.  However,
441
+nothing other than this License grants you permission to propagate or
442
+modify any covered work.  These actions infringe copyright if you do
443
+not accept this License.  Therefore, by modifying or propagating a
444
+covered work, you indicate your acceptance of this License to do so.
445
+
446
+  10. Automatic Licensing of Downstream Recipients.
447
+
448
+  Each time you convey a covered work, the recipient automatically
449
+receives a license from the original licensors, to run, modify and
450
+propagate that work, subject to this License.  You are not responsible
451
+for enforcing compliance by third parties with this License.
452
+
453
+  An "entity transaction" is a transaction transferring control of an
454
+organization, or substantially all assets of one, or subdividing an
455
+organization, or merging organizations.  If propagation of a covered
456
+work results from an entity transaction, each party to that
457
+transaction who receives a copy of the work also receives whatever
458
+licenses to the work the party's predecessor in interest had or could
459
+give under the previous paragraph, plus a right to possession of the
460
+Corresponding Source of the work from the predecessor in interest, if
461
+the predecessor has it or can get it with reasonable efforts.
462
+
463
+  You may not impose any further restrictions on the exercise of the
464
+rights granted or affirmed under this License.  For example, you may
465
+not impose a license fee, royalty, or other charge for exercise of
466
+rights granted under this License, and you may not initiate litigation
467
+(including a cross-claim or counterclaim in a lawsuit) alleging that
468
+any patent claim is infringed by making, using, selling, offering for
469
+sale, or importing the Program or any portion of it.
470
+
471
+  11. Patents.
472
+
473
+  A "contributor" is a copyright holder who authorizes use under this
474
+License of the Program or a work on which the Program is based.  The
475
+work thus licensed is called the contributor's "contributor version".
476
+
477
+  A contributor's "essential patent claims" are all patent claims
478
+owned or controlled by the contributor, whether already acquired or
479
+hereafter acquired, that would be infringed by some manner, permitted
480
+by this License, of making, using, or selling its contributor version,
481
+but do not include claims that would be infringed only as a
482
+consequence of further modification of the contributor version.  For
483
+purposes of this definition, "control" includes the right to grant
484
+patent sublicenses in a manner consistent with the requirements of
485
+this License.
486
+
487
+  Each contributor grants you a non-exclusive, worldwide, royalty-free
488
+patent license under the contributor's essential patent claims, to
489
+make, use, sell, offer for sale, import and otherwise run, modify and
490
+propagate the contents of its contributor version.
491
+
492
+  In the following three paragraphs, a "patent license" is any express
493
+agreement or commitment, however denominated, not to enforce a patent
494
+(such as an express permission to practice a patent or covenant not to
495
+sue for patent infringement).  To "grant" such a patent license to a
496
+party means to make such an agreement or commitment not to enforce a
497
+patent against the party.
498
+
499
+  If you convey a covered work, knowingly relying on a patent license,
500
+and the Corresponding Source of the work is not available for anyone
501
+to copy, free of charge and under the terms of this License, through a
502
+publicly available network server or other readily accessible means,
503
+then you must either (1) cause the Corresponding Source to be so
504
+available, or (2) arrange to deprive yourself of the benefit of the
505
+patent license for this particular work, or (3) arrange, in a manner
506
+consistent with the requirements of this License, to extend the patent
507
+license to downstream recipients.  "Knowingly relying" means you have
508
+actual knowledge that, but for the patent license, your conveying the
509
+covered work in a country, or your recipient's use of the covered work
510
+in a country, would infringe one or more identifiable patents in that
511
+country that you have reason to believe are valid.
512
+
513
+  If, pursuant to or in connection with a single transaction or
514
+arrangement, you convey, or propagate by procuring conveyance of, a
515
+covered work, and grant a patent license to some of the parties
516
+receiving the covered work authorizing them to use, propagate, modify
517
+or convey a specific copy of the covered work, then the patent license
518
+you grant is automatically extended to all recipients of the covered
519
+work and works based on it.
520
+
521
+  A patent license is "discriminatory" if it does not include within
522
+the scope of its coverage, prohibits the exercise of, or is
523
+conditioned on the non-exercise of one or more of the rights that are
524
+specifically granted under this License.  You may not convey a covered
525
+work if you are a party to an arrangement with a third party that is
526
+in the business of distributing software, under which you make payment
527
+to the third party based on the extent of your activity of conveying
528
+the work, and under which the third party grants, to any of the
529
+parties who would receive the covered work from you, a discriminatory
530
+patent license (a) in connection with copies of the covered work
531
+conveyed by you (or copies made from those copies), or (b) primarily
532
+for and in connection with specific products or compilations that
533
+contain the covered work, unless you entered into that arrangement,
534
+or that patent license was granted, prior to 28 March 2007.
535
+
536
+  Nothing in this License shall be construed as excluding or limiting
537
+any implied license or other defenses to infringement that may
538
+otherwise be available to you under applicable patent law.
539
+
540
+  12. No Surrender of Others' Freedom.
541
+
542
+  If conditions are imposed on you (whether by court order, agreement or
543
+otherwise) that contradict the conditions of this License, they do not
544
+excuse you from the conditions of this License.  If you cannot convey a
545
+covered work so as to satisfy simultaneously your obligations under this
546
+License and any other pertinent obligations, then as a consequence you may
547
+not convey it at all.  For example, if you agree to terms that obligate you
548
+to collect a royalty for further conveying from those to whom you convey
549
+the Program, the only way you could satisfy both those terms and this
550
+License would be to refrain entirely from conveying the Program.
551
+
552
+  13. Use with the GNU Affero General Public License.
553
+
554
+  Notwithstanding any other provision of this License, you have
555
+permission to link or combine any covered work with a work licensed
556
+under version 3 of the GNU Affero General Public License into a single
557
+combined work, and to convey the resulting work.  The terms of this
558
+License will continue to apply to the part which is the covered work,
559
+but the special requirements of the GNU Affero General Public License,
560
+section 13, concerning interaction through a network will apply to the
561
+combination as such.
562
+
563
+  14. Revised Versions of this License.
564
+
565
+  The Free Software Foundation may publish revised and/or new versions of
566
+the GNU General Public License from time to time.  Such new versions will
567
+be similar in spirit to the present version, but may differ in detail to
568
+address new problems or concerns.
569
+
570
+  Each version is given a distinguishing version number.  If the
571
+Program specifies that a certain numbered version of the GNU General
572
+Public License "or any later version" applies to it, you have the
573
+option of following the terms and conditions either of that numbered
574
+version or of any later version published by the Free Software
575
+Foundation.  If the Program does not specify a version number of the
576
+GNU General Public License, you may choose any version ever published
577
+by the Free Software Foundation.
578
+
579
+  If the Program specifies that a proxy can decide which future
580
+versions of the GNU General Public License can be used, that proxy's
581
+public statement of acceptance of a version permanently authorizes you
582
+to choose that version for the Program.
583
+
584
+  Later license versions may give you additional or different
585
+permissions.  However, no additional obligations are imposed on any
586
+author or copyright holder as a result of your choosing to follow a
587
+later version.
588
+
589
+  15. Disclaimer of Warranty.
590
+
591
+  THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
592
+APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
593
+HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
594
+OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
595
+THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
596
+PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
597
+IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
598
+ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
599
+
600
+  16. Limitation of Liability.
601
+
602
+  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
603
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
604
+THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
605
+GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
606
+USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
607
+DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
608
+PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
609
+EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
610
+SUCH DAMAGES.
611
+
612
+  17. Interpretation of Sections 15 and 16.
613
+
614
+  If the disclaimer of warranty and limitation of liability provided
615
+above cannot be given local legal effect according to their terms,
616
+reviewing courts shall apply local law that most closely approximates
617
+an absolute waiver of all civil liability in connection with the
618
+Program, unless a warranty or assumption of liability accompanies a
619
+copy of the Program in return for a fee.
620
+
621
+                     END OF TERMS AND CONDITIONS
622
+
623
+            How to Apply These Terms to Your New Programs
624
+
625
+  If you develop a new program, and you want it to be of the greatest
626
+possible use to the public, the best way to achieve this is to make it
627
+free software which everyone can redistribute and change under these terms.
628
+
629
+  To do so, attach the following notices to the program.  It is safest
630
+to attach them to the start of each source file to most effectively
631
+state the exclusion of warranty; and each file should have at least
632
+the "copyright" line and a pointer to where the full notice is found.
633
+
634
+    <one line to give the program's name and a brief idea of what it does.>
635
+    Copyright (C) <year>  <name of author>
636
+
637
+    This program is free software: you can redistribute it and/or modify
638
+    it under the terms of the GNU General Public License as published by
639
+    the Free Software Foundation, either version 3 of the License, or
640
+    (at your option) any later version.
641
+
642
+    This program is distributed in the hope that it will be useful,
643
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
644
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
645
+    GNU General Public License for more details.
646
+
647
+    You should have received a copy of the GNU General Public License
648
+    along with this program.  If not, see <https://www.gnu.org/licenses/>.
649
+
650
+Also add information on how to contact you by electronic and paper mail.
651
+
652
+  If the program does terminal interaction, make it output a short
653
+notice like this when it starts in an interactive mode:
654
+
655
+    <program>  Copyright (C) <year>  <name of author>
656
+    This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
657
+    This is free software, and you are welcome to redistribute it
658
+    under certain conditions; type `show c' for details.
659
+
660
+The hypothetical commands `show w' and `show c' should show the appropriate
661
+parts of the General Public License.  Of course, your program's commands
662
+might be different; for a GUI interface, you would use an "about box".
663
+
664
+  You should also get your employer (if you work as a programmer) or school,
665
+if any, to sign a "copyright disclaimer" for the program, if necessary.
666
+For more information on this, and how to apply and follow the GNU GPL, see
667
+<https://www.gnu.org/licenses/>.
668
+
669
+  The GNU General Public License does not permit incorporating your program
670
+into proprietary programs.  If your program is a subroutine library, you
671
+may consider it more useful to permit linking proprietary applications with
672
+the library.  If this is what you want to do, use the GNU Lesser General
673
+Public License instead of this License.  But first, please read
674
+<https://www.gnu.org/licenses/why-not-lgpl.html>.
0 675
deleted file mode 100644
... ...
@@ -1,4 +0,0 @@
1
-Simple. Just move the "shelltube" script along with
2
-the scripts in lib/ into your PATH.
3
-Then-- boom, installed.
4
-Groovy.
5 0
deleted file mode 100644
... ...
@@ -1,13 +0,0 @@
1
-Copyright (c) 2017, Jade Levesque
2
-
3
-Permission to use, copy, modify, and/or distribute this software for any
4
-purpose with or without fee is hereby granted, provided that the above
5
-copyright notice and this permission notice appear in all copies.
6
-
7
-THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
8
-WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
9
-MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
10
-ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
11
-WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
12
-ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
13
-OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
14 0
deleted file mode 100644
... ...
@@ -1,3 +0,0 @@
1
-PREFIX=/usr/local
2
-install:
3
-	install -m 0755 shelltube lib/* $(PREFIX)/bin/
4 0
deleted file mode 100644
... ...
@@ -1,102 +0,0 @@
1
-![Shelltube](https://cloud.githubusercontent.com/assets/7250745/21452795/52fcd6ea-c901-11e6-871b-bd646f2d7c49.png)
2
-
3
-shellTube is a collection of (pretty POSIX) shell scripts to
4
-browse YouTube quickly, efficiently, and without the bloat
5
-most command-line clients require.
6
-
7
-shellTube is written in pure shell; its only dependencies
8
-are any modern shell (pdksh, bash, zsh), curl/wget, and
9
-vlc/mplayer/kaffeine.
10
-
11
-Even these dependencies, though, can easily be changed. If,
12
-for example, you don't have vlc, you can just modify a
13
-single line and be good-to-go using another player.
14
-
15
-Also, shellTube doesn't use the YouTube API at all. This
16
-avoids the annoying red-tapey stuff that goes with it -- IDs,
17
-registration, quotas -- but has some disadvantages. We'll
18
-power through the downsides, though! :)
19
-
20
-
21
-Usage
22
-shellTube is quite simple to use; this tutorial will go over
23
-the usage of the wrapper script, `shelltube`.
24
-When running the script, you'll see a prompt:
25
-
26
-```
27
- >>
28
-```
29
-
30
-In this prompt you can type any of the following commands:
31
-
32
-| (short) command syntax | description |
33
-| --- | --- |
34
-| (`!`) `about` | View the about page. |
35
-| (`cls`) `clear` | Clear the screen. |
36
-| (`dl`) `download [URL] ` | Download the selected/specified video. |
37
-| `exit` | Exit Shelltube. |
38
-| (`?`) `help` | Display this message. |
39
-| (`md`) `metadata [URL]` | Display selected/specified video's metadata. |
40
-| (`//`) `playlist URL` `playlist ID` | View playlist based on `URL` or `ID`. |
41
-| (`/`) `search TERM` | Perform a search for `TERM`. |
42
-| (`str`) `stream [URL]` | Stream the selected/specified video. |
43
-| (`sel`) `video URL` `video ID` | Select video based on `URL` or `ID`. |
44
-| (`lq`) `queue` | Lists all videos in the queue. |
45
-| (`sq`) `squeue` | Streams all videos in the queue. |
46
-| (`dq`) `dqueue` | Downloads all videos in the queue. |
47
-
48
-In [brackets], optional arguments are written.
49
-
50
-You can use shellTube in one of two ways (or both):
51
-
52
-1. By selecting a video and then doing something with it
53
-2. By doing something and specifying the video
54
-
55
-Method A entails using either the `video` or `search`
56
-command to select a video, which will then be displayed
57
-before the prompt like so:
58
-
59
-```
60
-$VIDEO-ID-HERE >>
61
-```
62
-
63
-When a video is selected, you use the `download`, `stream`,
64
-or `metadata` commands without arguments to act on the
65
-video.
66
-
67
-Method B entails just using the `download`, `stream`, or
68
-`metadata` commands while using a URL or video ID as an
69
-argument.
70
-
71
-For example:
72
-
73
-```
74
- >> download $VIDEO-ID-HERE
75
-```
76
-
77
-You can also download or stream multiple videos in a row
78
-without user input with the queue.
79
-The queue is a list of video IDs in the file `/tmp/yt-queue`
80
-You can add to the queue manually or while looking at
81
-search results, playlist videos, or channel videos by inputting
82
-`*` rather than a number when prompted. This adds every video 
83
-listed to the queue.
84
-When you're back at the main prompt, you can enter `lq`, `dq`,
85
-or `sq` to list, download, or stream the queued videos.
86
-
87
-You could opt to not use this interactive wrapper script and
88
-instead just use the `yt-down`, `yt-search`, and
89
-`yt-metadata` scripts on their own.
90
-
91
-They are each pretty simple, and you can read their USAGE
92
-messages at the top of each script.
93
-
94
-
95
-Licensing
96
-All of ST is released under the
97
-[ISC](https://opensource.org/licenses/ISC) license.
98
-
99
-Except for the `y-down` script, which is released under the
100
-[GPLv2](https://www.gnu.org/licenses/gpl-2.0.html).
101 0
new file mode 100644
... ...
@@ -0,0 +1,64 @@
1
+===============================================================================
2
+SHELLTUBE                                    Shell scripts for easy YT-browsing
3
+===============================================================================
4
+shelltube will be a collection of (pretty POSIX) shell scripts to
5
+browse YouTube quickly, and entirely without captive UIs.
6
+Right now, there's only one script, yt-search
7
+
8
+shelltube is written in pure shell; its only dependencies
9
+are any modern shell (pdksh, bash, zsh) and curl/wget/ftp.
10
+Your terminal should accept ANSI color-codes, too~
11
+
12
+Before, shelltube was a set of scripts that culimated in a wrapper
13
+script for browsing Youtube (like mpsyt). You could even download
14
+videos from YT in pure shell! But, now, all videos require JS execution
15
+to download (as far as I can tell), so it stopped working.
16
+
17
+Now I'm refocusing a bit, ditching the wrapper script (begone, captive UIs,
18
+ye spectre of ole!), and starting from scratch. :)
19
+
20
+
21
+
22
+----------------------------------------
23
+USAGE
24
+----------------------------------------
25
+There is one script that makes up shelltube:
26
+	* yt-search
27
+
28
+yt-search lists videos matching a certain search query.
29
+	USAGE: yt-search [-csmb] query
30
+
31
+Each option [-csmb] represents a different format-method.
32
+	-b  	big      	TITLE \n DURATION | VIEWS | URL
33
+	-m	medium   	TITLE | DURATION | URL
34
+	-s	small    	TITLE | URL
35
+	-c	compact 	TITLE | ID
36
+
37
+Big takes up two lines, while the rest only use one.
38
+If you're piping output, you might wanna usa -m, -s, or -c.
39
+
40
+
41
+
42
+There is another script that comes with shelltube (which it uses
43
+extensively:
44
+	* gendl
45
+
46
+gendl can download files on a system that has at least one of these:
47
+	* ftp
48
+	* wget
49
+	* curl
50
+
51
+... to stdout or to a file.
52
+
53
+yt-search uses gendl--
54
+so make sure they're both in the same directory (or, at least, that
55
+gendl is in your $PATH)
56
+
57
+
58
+
59
+----------------------------------------
60
+BORING STUFF
61
+----------------------------------------
62
+License is in COPYING.txt (GNU GPLv3~! <3)
63
+Author is Jenga Phoenix <jadedctrl@teknik.io>
64
+Sauce is at https://git.eunichx.us/shelltube
0 65
new file mode 100644
... ...
@@ -0,0 +1,44 @@
1
+At some point in time, this SHOULD be the readme. It isn't right now, obviously.
2
+
3
+===============================================================================
4
+SHELLTUBE                                    Shell scripts for easy YT-browsing
5
+===============================================================================
6
+shelltube is a collection of (pretty POSIX) shell scripts to
7
+browse YouTube quickly, and entirely without captive UIs.
8
+
9
+shellTube is written in pure shell; its only dependencies
10
+are any modern shell (pdksh, bash, zsh) and curl/wget/ftp.
11
+Your terminal should accept ANSI color-codes, too~
12
+
13
+
14
+
15
+----------------------------------------
16
+USAGE
17
+----------------------------------------
18
+There are three different scripts that make up shelltube:
19
+	* yt-search
20
+	* yt-channel
21
+	* yt-meta
22
+
23
+In all three scripts:
24
+	'index' means what page of results you're on--
25
+	'results' means how many of them will be displayed.
26
+
27
+yt-search lists videos matching a certain search query.
28
+	USAGE: yt-search [-i index] [-r results] query
29
+
30
+
31
+yt-channel lists the videos of a given channel.
32
+	USAGE: yt-channel [-i index] [-r results] URL/ID/name
33
+
34
+yt-meta lists the metadata of a given video
35
+	USAGE: yt-meta URL/ID
36
+
37
+
38
+
39
+----------------------------------------
40
+BORING STUFF
41
+----------------------------------------
42
+License is in COPYING.txt (GNU GPLv3~! <3)
43
+Author is Jenga Phoenix <jadedctrl@teknik.io>
44
+Sauce is at https://git.eunichx.us/shelltube
0 45
new file mode 100755
... ...
@@ -0,0 +1,155 @@
1
+#!/bin/sh
2
+##############################
3
+# name: gendl
4
+# lisc: gnu gplv3
5
+# desc: download to stdout or
6
+#       file, independent of
7
+#       a specific downloader.
8
+#       ftp/wget/curl support.
9
+# main: jadedctrl
10
+##############################
11
+
12
+# usage: gendl [-o output] url
13
+
14
+
15
+
16
+#---------------------------------------
17
+# backend bits
18
+
19
+# NIL --> STRING
20
+# return the download program you're using
21
+function download_program
22
+{
23
+	programs="ftp curl wget"
24
+	current=""
25
+
26
+	for program in $programs
27
+	do
28
+		if whereis $program > /dev/null
29
+		then
30
+			current=$program
31
+		fi
32
+	done
33
+
34
+	if uname -s | grep -e "LibertyBSD" -e "OpenBSD" > /dev/null
35
+	then
36
+		current="ftp"
37
+	fi
38
+
39
+	echo "$current"
40
+}
41
+
42
+# STRING PATH --> NIL
43
+# download URL $1 to stdout
44
+function download_stdout
45
+{
46
+	program=$(download_program)
47
+	url=$1
48
+
49
+	case "$program" in
50
+		"ftp")
51
+			output="$(ftp -VMo- $url)"
52
+			;;
53
+		"curl")
54
+			output="$(curl $url)"
55
+			;;
56
+		"wget")
57
+			output="$(wget --quiet -O $url)"
58
+			;;
59
+	esac
60
+
61
+	return_code=$?
62
+
63
+	echo "$output"
64
+	return $return_code
65
+}
66
+
67
+# STRING PATH --> NIL
68
+# download URL $1 to path $2
69
+function download_file
70
+{
71
+	program=$(download_program)
72
+	url=$1
73
+	path=$2
74
+
75
+	case "$program" in
76
+		"ftp")
77
+			ftp -VMU "." -o $path $url
78
+			;;
79
+		"curl")
80
+			curl -o $path $url
81
+			;;
82
+		"wget")
83
+			wget --quiet -O $path $url
84
+			;;
85
+	esac
86
+
87
+	return_code=$?
88
+
89
+	if test $return_code -ne 0
90
+	then
91
+		rm $path 2> /dev/null
92
+		# for consistency in behavior; wget saves 404s anyway, whereas
93
+		# ftp doesn't save anything from 404s, etc.
94
+	fi
95
+
96
+	return $return_code
97
+}
98
+
99
+
100
+
101
+# --------------------------------------
102
+# front-end string-manip
103
+
104
+# STRING --> STRING
105
+# return the last word in a string
106
+function last_word
107
+{
108
+	string="$1"
109
+
110
+	echo "$string" \
111
+	| rev \
112
+	| sed 's% .*%%' \
113
+	| rev
114
+}
115
+
116
+function usage
117
+{
118
+	echo "usage: gendl [-o output] URL"
119
+}
120
+
121
+
122
+
123
+# --------------------------------------
124
+# invocation
125
+
126
+args="$(getopt o: $*)"
127
+if test $? -ne 0 || test -z "$@"
128
+then
129
+	usage
130
+	exit 2
131
+fi
132
+
133
+
134
+set -- $args
135
+while test $# -ne 0
136
+do
137
+	case "$1"
138
+	in
139
+		-o)
140
+			download_path="$2"; shift; shift;;
141
+		--)
142
+			shift; break;;
143
+	esac
144
+done
145
+
146
+
147
+url="$(last_word "$@")"
148
+
149
+
150
+if test -n "$download_path"
151
+then
152
+	download_file $url $download_path
153
+else
154
+	download_stdout "$url"
155
+fi
0 156
deleted file mode 100755
... ...
@@ -1,23 +0,0 @@
1
-#!/bin/sh
2
-#####################
3
-# Name: st-download.sh
4
-# Lisc: ISC
5
-# Main: jadedctrl
6
-# Desc: No beer and no TV
7
-#       make   Homer   go
8
-#       something-something
9
-#       Cxu ne?
10
-#####################
11
-
12
-if test -z "$download_cmd"
13
-then
14
-    if command -v wget > /dev/null
15
-    then
16
-        wget -q "$1" -O "$2" 
17
-    elif command -v curl > /dev/null
18
-    then
19
-        curl -s "$1" -o "$2"
20
-    fi
21
-else
22
-    $download_cmd
23
-fi
24 0
deleted file mode 100755
... ...
@@ -1,28 +0,0 @@
1
-#!/bin/sh
2
-#####################
3
-# Name: st-video.sh
4
-# Date: 2016-12-22
5
-# Lisc: ISC
6
-# Main: jadedctrl
7
-# Desc: Does a thing with
8
-#       a video-thingy thing
9
-#       dsfgbvesrht fd
10
-#####################
11
-
12
-if [ -e "$HOME/.config/shelltube" ]
13
-then
14
-    . "$HOME/.config/shelltube"
15
-fi
16
-
17
-if test -z "$player_cmd"
18
-then
19
-    if command -v vlc > /dev/null
20
-    then
21
-        vlc --play-and-exit "${1}"
22
-    elif command -v mplayer > /dev/null
23
-    then
24
-        mplayer --quiet "${1}"
25
-    fi
26
-else
27
-    $player_cmd "${1}"
28
-fi
29 0
deleted file mode 100755
... ...
@@ -1,191 +0,0 @@
1
-#!/bin/sh
2
-#####################
3
-# Name: yt-channel.sh
4
-# Lisc: ISC
5
-# Main: jadedctrl
6
-# Desc: Display a channel's videos
7
-#       or details in easy-to-read
8
-#       and easy-to-parse results.
9
-#####################
10
-
11
-# Usage: yt-channel.sh [-uci] userid||channel
12
-
13
-if [ -e "$HOME/.config/shelltube" ]
14
-then
15
-    . "$HOME/.config/shelltube"
16
-else
17
-    results=21
18
-fi
19
-
20
-if [ -e "./lib/yt-meta" ]
21
-then
22
-    alias yt-channel="./lib/yt-channel"
23
-    alias yt-search="./lib/yt-down"
24
-    alias yt-meta="./lib/yt-meta"
25
-    alias yt-search="./lib/yt-search"
26
-    alias yt-down="./lib/yt-channel"
27
-    alias st-download="./lib/st-download"
28
-    alias st-video="./lib/st-video"
29
-fi
30
-
31
-interactive_mode=0
32
-channel_file="/tmp/$(mktemp -u yt-channel_XXXXXX)"
33
-
34
-# I really need to work out a better way to take flags.
35
-# This is just awful.
36
-# ... I'll cross that bridge later.
37
-
38
-
39
-if [ "$1" = "-u" ]
40
-then
41
-    type="user"
42
-    st-download "https://youtube.com/user/$2/videos" "$channel_file"
43
-elif [ "$1" = "-iu" ]
44
-then
45
-    output="$3"
46
-    interactive_mode=1
47
-    type="user"
48
-    st-download "https://youtube.com/user/$2/videos" "$channel_file"
49
-elif [ "$1" = "-c" ]
50
-then
51
-    type="channel"
52
-    st-download "https://youtube.com/channel/$2/videos" "$channel_file"
53
-elif [ "$1" = "-ic" ]
54
-then
55
-    output="$3"
56
-    interactive_mode=1
57
-    type="channel"
58
-    st-download "https://youtube.com/channel/$2/videos" "$channel_file"
59
-elif [ "$1" = "-uc" ] || [ -k "$2" ] 
60
-then
61
-    echo "Usage: yt-channel.sh [-uci] userid||channel [output]"
62
-    echo "Make sure to use either the -u flag or the -c flag--"
63
-    echo "*not* both! Also, specify a userid or channel name."
64
-    exit 1
65
-else
66
-    echo "Usage: yt-channel.sh [-uc] userid||channel"
67
-    exit 1
68
-fi
69
-
70
-get_input() {
71
-    printf '\033[0;32m>>>\033[0m '
72
-    read -r n
73
-
74
-    if [ "$n" = "exit" ]
75
-    then
76
-        exit
77
-    fi
78
-    if [ "$n" == "*" ]
79
-    then
80
-        cat $temp_file | while IFS='' read -r CUR_LINE
81
-        do
82
-            echo "$CUR_LINE" | sed 's/.*href="\/watch?v=//' | sed 's/".*//' >> $output
83
-        done
84
-        cp $output /tmp/yt-queue
85
-#    test $n -ge 0
86
-    elif [ $? -gt 1 ] 
87
-    then
88
-        echo "Bad input, mate. Type in a valid number or 'exit'."
89
-        get_input
90
-    elif [ $n -gt 20 ]
91
-    then
92
-        echo "Out of range. Type in a valid number or 'exit'."
93
-        get_input
94
-    elif [ $n -gt 0 ] && [ $n -lt 20 ]
95
-    then
96
-        sed -n "${n}p" "$temp_file" | sed 's/.*href="\/watch?v=//' | sed 's/".*//' > "$output"
97
-    else
98
-        echo "Bad input, mate. Type in a valid number or 'exit'."
99
-        get_input
100
-    fi
101
-}
102
-
103
-
104
-row=0
105
-
106
-# Now for displaying the search results
107
-temp_file="/tmp/$(mktemp -u yt-channel_XXXXXX)"
108
-
109
-grep "href=\"\/watch?v=" "$channel_file" | grep "title=" | grep -v \
110
-     "<span class=\"yt-thumb-simple\"" > "$temp_file"
111
-item_num=0
112
-cat "$temp_file" | while IFS='' read -r CUR_LINE 
113
-do 
114
-    item_num=$((item_num+1)) 
115
-    LINE="$(echo "$CUR_LINE" | sed 's/<span class=\"yt-badge \" >.*//')"
116
-    LINE="$(echo "$LINE" | sed 's/views<\/li>.*//')"
117
-    LINE="$(echo "$LINE" | sed 's/title="Verified"//')"
118
-
119
-    if [ $row -eq 1 ]
120
-    then
121
-        #color='\033[1;34m'
122
-        #color2='\033[1;34m'
123
-        printf '\033[1;34m'
124
-        row=0
125
-    elif [ $row -eq 0 ]
126
-    then
127
-        #color='\033[1;31m'
128
-        #color2='\033[1;31m'
129
-        printf '\033[1;31m'
130
-        row=1
131
-    fi
132
-
133
-    if echo "$LINE" | grep "View full playlist" > /dev/null
134
-    then
135
-        type="Playlist"
136
-        title=$(echo "$LINE" | sed 's/.*title="//' | sed 's/".*//')
137
-        items=$(echo "$LINE" | sed 's/.*View full playlist (//' | sed 's/).*//')
138
-        if [ $item_num -ge $((results+1)) ]
139
-        then
140
-            break
141
-        elif [ $item_num -lt 10 ]
142
-        then
143
-            printf '%s.  ' "$item_num"
144
-        else
145
-            printf '%s. ' "$item_num"
146
-        fi
147
-        printf '%s' "$title"
148
-        printf '    '
149
-        printf '%s | %s' "$type" "$items"
150
-        printf '    '
151
-    else
152
-        type="Video"
153
-        duration=$(echo "$LINE" | sed 's/.*Duration: //' | sed 's/\..*//')
154
-        itemid=$(echo "$LINE" | sed 's/.*href="\/watch?v=//' | sed 's/".*//')
155
-        title=$(echo "$LINE" | sed 's/.* title="//' | sed 's/".*//')
156
-
157
-        if [ $item_num -ge $((results+1)) ]
158
-        then
159
-            break
160
-        elif [ $item_num -lt 10 ]
161
-        then
162
-            printf '%s.  ' "$item_num"
163
-        else
164
-            printf '%s. ' "$item_num"
165
-        fi
166
-        echo "$title"
167
-        printf '    '
168
-        i=0
169
-        while [ $i -lt 9 ]
170
-        do
171
-            i=$((i+1))
172
-            char=$(echo "$duration" | cut -c$i)
173
-            if [ -z "$char" ]
174
-            then
175
-                printf ' '
176
-            else
177
-                printf '%s' "$char"
178
-            fi
179
-        done
180
-        printf ' | %s\n' "$itemid"
181
-    fi
182
-done
183
-
184
-if [ $interactive_mode -eq 1 ]
185
-then
186
-    get_input
187
-fi
188
-
189
-printf '\033[0m'
190
-
191
-rm "$temp_file"
192 0
deleted file mode 100755
... ...
@@ -1,140 +0,0 @@
1
-#!/bin/sh
2
-#####################
3
-# Name: yt-down
4
-# Lisc: GPLv2
5
-# Auth: iluaster
6
-# Main: jadedctrl
7
-# Desc: Fetches YT videos.
8
-#####################
9
-
10
-# Based on https://github.com/iluaster/Youtube_downloader
11
-
12
-# Usage: yt-down -[sSD] $video_id
13
-# -s for stream; -S for stream and skip prompt; 
14
-# -D for download and skip prompt; No arg for download.
15
-
16
-
17
-if [ "$1" = "-s" ]
18
-then
19
-    stream_mode=1
20
-    id=$2
21
-elif [ "$1" = "-S" ]
22
-then
23
-    stream_mode=1
24
-    skip_prompt=1
25
-    id=$2
26
-elif [ "$1" = "-D" ]
27
-then
28
-    stream_mode=0
29
-    skip_prompt=1
30
-    id=$2
31
-else
32
-    stream_mode=0
33
-    id=$1
34
-fi
35
-
36
-if [ -e "./lib/yt-meta" ]
37
-then
38
-    alias yt-channel="./lib/yt-channel"
39
-    alias yt-search="./lib/yt-down"
40
-    alias yt-meta="./lib/yt-meta"
41
-    alias yt-search="./lib/yt-search"
42
-    alias yt-down="./lib/yt-channel"
43
-    alias st-download="./lib/st-download"
44
-    alias st-video="./lib/st-video"
45
-fi
46
-
47
-
48
-if echo "$id" | grep "youtube.com"
49
-then 
50
-    id="$(echo "$id" | sed 's/.*video_id=//')"
51
-elif [ -z "$id" ]
52
-then
53
-    echo "No video specified."
54
-    exit 1
55
-else
56
-    id="$id"
57
-fi
58
-    
59
-name="http://www.youtube.com/get_video_info?video_id=$id"
60
-
61
-declare -i line=0 2> /dev/null
62
-
63
-if $? 2> /dev/null
64
-then
65
-    echo > /dev/null
66
-else
67
-    line=0
68
-fi
69
-
70
-select_option ()
71
-{